<?php

namespace aelvan\imager\effects;

use aelvan\imager\services\ImagerService;
use Imagine\Gd\Image as GdImage;
use Imagine\Imagick\Image as ImagickImage;

class NegativeEffect implements ImagerEffectsInterface
{

    /**
     * @param GdImage|ImagickImage        $imageInstance
     * @param array|string|int|float|null $params
     */
    public static function apply($imageInstance, $params)
    {
        if (ImagerService::$imageDriver === 'gd') {
            $imageInstance->effects()->negative();
        }
        
        if (ImagerService::$imageDriver === 'imagick') {
            $imagickInstance = $imageInstance->getImagick();
            $imagickInstance->negateImage(false, \Imagick::CHANNEL_ALL);
        }
    }
}